<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Trackback (asm4trk) ***
// LAST UPDATE: 2009/05/30
// Version    : 2.81
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// asm4trk.php
//
//--------------------------------------------------------------------

if (!$errflg) {

	require BLOGN_MODDIR."asm4trk/function.php";

	$inifile = BLOGN_MODDIR."asm4trk/config.ini";
	$inis = file($inifile);
	list($mode, , $wt_half, $wt_one, $wt_two, $wt_four, $wt_lang, $wt_length, $wt_slash, $wt_ng, $wt_badua, $wt_noua, $wt_ref, $wt_title, $wt_blip, $wt_bldm) = explode(",", $inis[0]);

	$time_current = asm4trk_time_convert($date);
	$time_entered = asm4trk_time_convert($log[1]["date"]);
	$asm4trk_diff = $time_current - $time_entered;
	
	$asm4trk_excerpt = asm4trk_format_data(blogn_mbConv($_POST["excerpt"], 0, 4));
	if (strlen($asm4trk_excerpt) > 255) $asm4trk_excerpt = blogn_mbtrim($asm4trk_excerpt,252)."...";
	$asm4trk_excerpt = str_replace("-----", "&#x2d;---&#x2d;", $asm4trk_excerpt);

	$weight = 0;

if ($mode < 4) {
	// トラックバックスパム判定
	$asm4trk_err ="";
	if ($asm4trk_diff < 1800) {
		$weight += $wt_half;
		$asm4trk_err .= "[時間制限]";
	} elseif ($asm4trk_diff < 3600) {
		$weight += $wt_one;
		$asm4trk_err .= "[時間制限]";
	} elseif ($asm4trk_diff < 7200) {
		$weight += $wt_two;
		$asm4trk_err .= "[時間制限]";
	} elseif ($asm4trk_diff < 14400) {
		$weight += $wt_four;
		$asm4trk_err .= "[時間制限]";
	}
	
	if (!preg_match("/[ぁ-んァ-ヶ]{9}/", $asm4trk_excerpt)) {
		if ($wt_lang == 10 && $mode > 0) {
			res_xml(1,"TrackBack is not Permitted");
		} else {
			$weight += $wt_lang;
			$asm4trk_err .= "[非日本語]";
		}
	}
	
	if (strlen($_POST["excerpt"]) < 240) {
		$weight += $wt_length;
		$asm4trk_err .= "[文字数]";
	}

	if (preg_match("/\/$/", $url) && !preg_match("/rakuten/i", $url)) {
		if ($wt_slash == 10 && $mode > 0) {
			res_xml(1,"TrackBack is not Permitted");
		} else {
			$weight += $wt_slash;
			$asm4trk_err .= "[URL末尾に/]";
		}
	}

	if ($blog_name == $title) {
		if ($wt_title == 10 && $mode > 0) {
			res_xml(1,"TrackBack is not Permitted");
		} else {
			$weight += $wt_title;
			$asm4trk_err .= "[記事名]";
		}
	}
	
	if (preg_match("/(Mozilla|Opera)/i", $user_agent)) {
		if ($wt_badua == 10 && $mode > 0) {
			res_xml(1,"TrackBack is not Permitted");
		} else {
			$weight += $wt_badua;
			$asm4trk_err .= "[不正UA]";
		}
	} elseif (!$user_agent && !preg_match("/blog\.goo\.ne\.jp|exblog\.jp/", $url)) {
		$weight += $wt_noua;
		$asm4trk_err .= "[不明UA]";
	}

	$data = fopen(BLOGN_MODDIR."asm4trk/ngwd.dat", "r");
	$ng_wd = fgets($data, 2048);
	if (strlen($ng_wd)) {
		$ng_wd = preg_replace("/[,]+$/", "", $ng_wd);
		$ng_wd = explode(",", $ng_wd);
		if (is_array($ng_wd)) {
			foreach ($ng_wd as $deny_wd) {
				if (preg_match("/$deny_wd/i", $asm4trk_excerpt) || preg_match("/$deny_wd/i", $url)) {
					$weight += $wt_ng;
					$asm4trk_err .= "[禁止語]";
				}
			}
		}
	}
	fclose($data);

	if ($weight < 10) {
//		if ($wt_blip) {
//			preg_match("/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/", $ip_addr, $ips);
//			$domain = $ips[4].'.'.$ips[3].'.'.$ips[2].'.'.$ips[1];
//			if (strstr(gethostbyname($domain.'.bsb.spamlookup.net'), "127.0.0")) {
//				$weight += $wt_blip;
//				$asm4trk_err .= "[スパムIP]";
//			}
//		}
		if ($wt_blip) {
			preg_match("/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/", $ip_addr, $ips);
			$domain = $ips[4].'.'.$ips[3].'.'.$ips[2].'.'.$ips[1];
			if (strstr(gethostbyname($domain.'.dnsbl.spam-champuru.livedoor.com'), "127.0.0")) {
				$weight += $wt_blip;
				$asm4trk_err .= "[スパムIP]";
			}
		}
		
		if ($wt_bldm) {
			$pattern = "/^(http:\/\/)([^\/]+)(\/.*$)/i";
			if (preg_match($pattern, $url, $match)) {
				$domain = $match[2]; 
				$path = $match[3]; 
			} else {
				exit();
			}
			$domain = preg_replace("/([\w]+\.)(ap\.teacup\.com)/", "\\2", $domain);
			// ドメイン・サブドメインで振り分け
			switch ($domain) {
				case "ameblo.jp":
				case "blog.drecom.jp";
				case "blog.goo.ne.jp":
				case "blog.livedoor.jp":
				case "blog.so-net.ne.jp":
				case "blogs.dion.ne.jp":
				case "blogs.yahoo.co.jp":
				case "curuhome.cururu.jp":
				case "d.hatena.ne.jp":
				case "diary.jp.aol.com":
				case "plaza.rakuten.co.jp":
				case "spaces.msn.com":
				case "yaplog.jp":
					$dir = explode("/", $path);
					$domain = $dir[1].'.'.$domain;
					break;
				case "ap.teacup.com":
					$dir = explode("/", $path);
					$domain = $dir[1].'.'.$match[2];
					break;
				case "shinshu.fm":
				case "ch.kitaguni.tv":
					$dir = explode("/", $path);
					$domain = $dir[2].$dir[1].'.'.$domain;
					break;
				case "doblog.com":
					$dir = explode("/", $path);
					$domain = $dir[3].$dir[2].$dir[1].'.'.$domain;
					break;
				default :
					$domain = $domain;
					break;
			}
			if (strstr(gethostbyname($domain.'.rbl.bulkfeeds.jp'), "127.0.0")) {
				$weight += $wt_bldm;
				$asm4trk_err .= "[スパムURL]";
			}
		}
	}

	if ($wt_ref && $weight < 10) {
		$page = strip_tags(get_html($url), '<a>'); //URLからHTMLを取得
		if ($page) {
			if (!ereg(BLOGN_HOMELINK, $page)) {
				$weight += $wt_ref;
				$asm4trk_err .= "[言及なし]";
			}
		}
	}
} else {
	$weight = 10;
}

	// ログ書き込み前にカンマ/改行を除去
	$asm4trk_blog_name = asm4trk_format_log($blog_name);
	$asm4trk_title = asm4trk_format_log($title);
	$asm4trk_url = asm4trk_format_log($url);
	$asm4trk_user_agent = asm4trk_format_log($user_agent);

	$asm4trk_data = $no.','.$asm4trk_err.','.$date.','.$asm4trk_blog_name.','.$asm4trk_title.','.$asm4trk_url.','.$asm4trk_excerpt.','.$ip_addr.','.$asm4trk_user_agent.','.$asm4trk_diff.','.$weight."\n";

	$asm4trk_file = BLOGN_MODDIR."/asm4trk/rejected.log";

	// ログに書き込み ＆ 受信拒否処理 (0: TEST MODE, 1: A MODE, 2: B MODE, 4: C MODE, 3: D MODE)
	switch ($mode) {
		case "1": // A Mode
			$fp = fopen($asm4trk_file, "a+");
			flock($fp, LOCK_EX);
			fwrite($fp, $asm4trk_data);
			flock($fp, LOCK_UN);
			fclose($fp);
			if ($weight >= 10) res_xml(1,"TrackBack is not Permitted");
			break;
		case "2": // B Mode
			if ($weight >= 10) {
				$fp = fopen($asm4trk_file, "a+");
				flock($fp, LOCK_EX);
				fwrite($fp, $asm4trk_data);
				flock($fp, LOCK_UN);
				fclose($fp);
				res_xml(1,"TrackBack is not Permitted");
			}
			break;
		case "4": // C Mode
			$fp = fopen($asm4trk_file, "a+");
			flock($fp, LOCK_EX);
			fwrite($fp, $asm4trk_data);
			flock($fp, LOCK_UN);
			fclose($fp);
			res_xml(0, "");
			break;
		case "3": // D Mode
			if ($weight >= 10) res_xml(1,"TrackBack is not Permitted");
			break;
		default:
			$fp = fopen($asm4trk_file, "a+");
			flock($fp, LOCK_EX);
			fwrite($fp, $asm4trk_data);
			flock($fp, LOCK_UN);
			fclose($fp);
			break;
	}
}
?>
